# mintegraladmobpk

A new flutter plugin project.

## Getting Started

This project is a starting point for a Flutter
[plug-in package](https://flutter.dev/developing-packages/),
a specialized package that includes platform-specific implementation code for
Android and/or iOS.

For help getting started with Flutter, view our 
[online documentation](https://flutter.dev/docs), which offers tutorials, 
samples, guidance on mobile development, and a full API reference.

import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:mintegraladmobpk/mintegraladmobpk.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    try {
      platformVersion = await Mintegraladmobpk.platformVersion;
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Flutter demo app'),
        ),
        body: Center(
            child: Column(
              mainAxisAlignment: MainAxisAlignment.center,
              children:[
                Text('Running on: $_platformVersion\n'),
                RaisedButton(
                  child: Text("Init advertisement"),
                  onPressed: initAdvertisement,
                  color: Colors.red,
                  textColor: Colors.white,
                  splashColor: Colors.grey,
                  padding: EdgeInsets.fromLTRB(10, 10, 10, 10),
                )
, RaisedButton(
                  child: Text("Load advertisement "),
                  onPressed: loadAdvertisement,
                  color: Colors.red,
                  textColor: Colors.white,
                  splashColor: Colors.grey,
                  padding: EdgeInsets.fromLTRB(10, 10, 10, 10),
                ),
                RaisedButton(
                  child: Text("Show advertisement "),
                  onPressed: showAdvertisement,
                  color: Colors.red,
                  textColor: Colors.white,
                  splashColor: Colors.grey,
                  padding: EdgeInsets.fromLTRB(10, 10, 10, 10),
                )

              ],
            )

        ),
      ),
    );
  }
  void initAdvertisement() async{
    await Mintegraladmobpk.initAdvertisement;

  }
  void loadAdvertisement() async{

    await Mintegraladmobpk.loaddAdvertisement;

  }
  void showAdvertisement() async{

    await Mintegraladmobpk.showAdvertisement;

  }
}


