package com.jshealth.mintegraladmob.mintegraladmobpk

import android.app.Activity
import android.util.Log
import android.widget.Toast
import com.jshealth.mintegraladmob.mintegraladmobpk.mediation.common.CommonConst
import com.jshealth.mintegraladmob.mintegraladmobpk.mediation.common.LifecycleListener
import com.jshealth.mintegraladmob.mintegraladmobpk.mediation.common.bean.AdSource
import com.jshealth.mintegraladmob.mintegraladmobpk.mediation.common.listener.MediationAdapterInitListener
import com.jshealth.mintegraladmob.mintegraladmobpk.mediation.common.listener.MediationAdapterInterstitialListener
import com.jshealth.mintegraladmob.mintegraladmobpk.mediation.out.handler.MediationInterstitialHandler
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar
import java.util.*


class MintegraladmobpkPlugin: MethodCallHandler {

    private var mediationInterstitialHandler: MediationInterstitialHandler? = null
    private var lifecycleListener: LifecycleListener? = null
  companion object {

      lateinit var activity :Activity;
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "mintegraladmobpk")
      channel.setMethodCallHandler(MintegraladmobpkPlugin())

         activity=registrar.activity()
    }
  }



  override fun onMethodCall(call: MethodCall, result: Result) {
    if(call.method == "initAdvertisement"){
        initManager()
    //  Toast.makeText(activity,"hello world",Toast.LENGTH_LONG).show()
    } else if (call.method == "loadAdvertisement") {
         load()
    } else if (call.method == "showAdvertisement") {
        show()
    }
   else if (call.method == "getPlatformVersion") {

      result.success("Android test${android.os.Build.VERSION.RELEASE}")
    } else {
      result.notImplemented()
    }
  }
    private fun initManager() {
        mediationInterstitialHandler = MediationInterstitialHandler()
        mediationInterstitialHandler!!.setMediationAdapterInitListener(object : MediationAdapterInitListener {
            override fun onInitSucceed() {
                Toast.makeText(activity, "onInitSucceed", Toast.LENGTH_LONG).show()
                Log.e("interstitial", "onInitSucceed")
            }

            override fun onInitFailed() {
                Toast.makeText(activity, "onInitFailed", Toast.LENGTH_LONG).show()
                Log.e("interstitial", "onInitFailed")
            }
        })
        val paramsMap: MutableMap<String, Any> = HashMap()
        //IronSource
        val adSource = AdSource()
        val ironsourceMap: MutableMap<String, Any> = HashMap()
        ironsourceMap["local"] = "88f1a7f5"
        adSource.localParams = ironsourceMap
        adSource.targetClass = "com.jshealth.mintegraladmob.mintegraladmobpk.mediation.adapter.iron.IronInterstitialAdapter"
        adSource.timeOut = 30000
        paramsMap["2"] = adSource

        //MTG
        val map: MutableMap<String, Any> = HashMap()
        val mtgAdSource = AdSource()
        map[CommonConst.KEY_APPID] = "128681"
        map[CommonConst.KEY_APPKEY] = "1f90b038e747fb09f3760a6a477d79aa"
        map[CommonConst.KEY_INTERSTITIALUNITID] = "250594"
        map[CommonConst.KEY_MUTE] = false
        mtgAdSource.localParams = map
        mtgAdSource.targetClass = "com.jshealth.mintegraladmob.mintegraladmobpk.mediation.adapter.mtg.MTGInterstitialAdapter"
        mtgAdSource.timeOut = 30000
        paramsMap["1"] = mtgAdSource
        mediationInterstitialHandler!!.setMediationAdapterInterstitialListener(object : MediationAdapterInterstitialListener {
            override fun loadSucceed() {
                Toast.makeText(activity, "loadSucceed", Toast.LENGTH_LONG).show()
            }

            override fun loadFailed(msg: String) {
                Toast.makeText(activity, "loadFailed:$msg", Toast.LENGTH_LONG).show()
            }

            override fun showSucceed() {
                Toast.makeText(activity, "showSucceed:", Toast.LENGTH_LONG).show()
            }

            override fun showFailed(msg: String) {
                Toast.makeText(activity, "showFailed:$msg", Toast.LENGTH_LONG).show()
            }

            override fun clicked(msg: String) {
                Toast.makeText(activity, "clicked:$msg", Toast.LENGTH_LONG).show()
            }

            override fun closed() {
                Toast.makeText(activity, "closed:", Toast.LENGTH_LONG).show()
            }
        })
        mediationInterstitialHandler!!.init(activity, paramsMap)
        lifecycleListener = mediationInterstitialHandler!!.getLifecycleListener()
    }
    fun load(){
        if (mediationInterstitialHandler != null) {
            mediationInterstitialHandler!!.load("")
        }
    }
    fun show(){
        if (mediationInterstitialHandler != null) {
            mediationInterstitialHandler!!.show("")
        }
    }
    fun isReady(){
        if (mediationInterstitialHandler != null) {
            Toast.makeText(activity, "ready:" + mediationInterstitialHandler!!.isReady(""), Toast.LENGTH_LONG).show()
        }
    }

  /*  protected fun onPause() {
        super.onPause()
        if (lifecycleListener != null) {
            lifecycleListener!!.onPause(this)
        }
    }

    protected fun onResume() {
        super.onResume()
        if (lifecycleListener != null) {
            lifecycleListener!!.onResume(this)
        }
    }*/
}
